from dotenv import load_dotenv
from msgspec import Struct

from intellibricks import Message, MessageRole, CompletionEngine

load_dotenv(override=True)


# Step #1: Define your response structure
class Joke(Struct):
    joke: str


messages = [
    Message(role=MessageRole.SYSTEM, content="You are a helpful assistant."),
    Message(role=MessageRole.USER, content="Hello, how are you?"),
    Message(role=MessageRole.ASSISTANT, content="I'm fine! And you? Intellibricks is awesome, isn't it? (This was completely generated by AI and not the owner of the project)"),
    Message(role=MessageRole.USER, content="I'm fine. Tell me a joke about soccer."),
]

engine = CompletionEngine()

response = engine.chat(
    messages=messages,
    response_format=Joke,
)

presidents_response = response.get_parsed()
print(presidents_response)
